Index: issm/trunk/src/c/objects/Param.cpp
===================================================================
--- issm/trunk/src/c/objects/Param.cpp	(revision 2913)
+++ issm/trunk/src/c/objects/Param.cpp	(revision 3332)
@@ -20,6 +20,4 @@
 /*Object constructors and destructor*/
 /*FUNCTION Param::constructor {{{1*/
-#undef __FUNCT__ 
-#define __FUNCT__  "Param constructor"
 Param::Param(int param_id, char* param_name, int param_type){
 
@@ -30,5 +28,5 @@
 		(param_type!=DOUBLEVEC) & (param_type!=DOUBLEMAT) & (param_type!=PETSCVEC) & (param_type!=PETSCMAT) 
 		){
-		throw ErrorException(__FUNCT__,exprintf("%s%i"," unknow parameter type ",param_type));
+		ISSMERROR(exprintf("%s%i"," unknow parameter type ",param_type));
 	}
 	stringarray=NULL;
@@ -94,5 +92,5 @@
 
 		default:
-			throw ErrorException(__FUNCT__,exprintf("%s%i","unknow parameter type ",type));
+			ISSMERROR(exprintf("%s%i","unknow parameter type ",type));
 	}
 }
@@ -212,5 +210,5 @@
 
 		default:
-			throw ErrorException(__FUNCT__,exprintf("%s%i","unknown parameter type",type));
+			ISSMERROR(exprintf("%s%i","unknown parameter type",type));
 	}
 
@@ -221,6 +219,4 @@
 /*}}}*/
 /*FUNCTION Param::Marshall {{{1*/
-#undef __FUNCT__
-#define __FUNCT__ "Marshall"
 
 void  Param::Marshall(char** pmarshalled_dataset){
@@ -315,5 +311,5 @@
 		
 		default:
-			throw ErrorException(__FUNCT__,exprintf("%s%i","unknown parameter type",type));
+			ISSMERROR(exprintf("%s%i","unknown parameter type",type));
 			break;
 	}
@@ -370,5 +366,5 @@
 
 		default:
-			throw ErrorException(__FUNCT__,exprintf("%s%i","unknown parameter type",type));
+			ISSMERROR(exprintf("%s%i","unknown parameter type",type));
 	}
 
@@ -384,6 +380,4 @@
 /*}}}*/
 /*FUNCTION Param::Echo {{{1*/
-#undef __FUNCT__ 
-#define __FUNCT__  "Param echo"
 void Param::Echo(void){
 
@@ -436,5 +430,5 @@
 
 		default:
-			throw ErrorException(__FUNCT__,exprintf("%s%i","unknow parameter type ",type));
+			ISSMERROR(exprintf("%s%i","unknow parameter type ",type));
 	}
 }
@@ -447,6 +441,4 @@
 /*}}}*/
 /*FUNCTION Param::DeepEcho {{{1*/
-#undef __FUNCT__ 
-#define __FUNCT__  "Param Deep Echo"
 void Param::DeepEcho(void){
 
@@ -498,5 +490,5 @@
 
 		default:
-			throw ErrorException(__FUNCT__,exprintf("%s%i","unknow parameter type ",type));
+			ISSMERROR(exprintf("%s%i","unknow parameter type ",type));
 	}
 }	
@@ -521,6 +513,4 @@
 /*}}}*/
 /*FUNCTION Param::GetParameterValue(Mat* pmat) {{{1*/
-#undef __FUNCT__ 
-#define __FUNCT__ "GetParameterValue"
 
 void  Param::GetParameterValue(Mat* pmat){
@@ -528,5 +518,5 @@
 	Mat  outmat=NULL;
 	
-	if(type!=PETSCMAT)  throw ErrorException(__FUNCT__,exprintf("%s%i"," error message: trying to recover a Petsc mat from a param with type",type));
+	if(type!=PETSCMAT)  ISSMERROR(exprintf("%s%i"," error message: trying to recover a Petsc mat from a param with type",type));
 	
 	if(mat){
@@ -547,29 +537,23 @@
 /*}}}*/
 /*FUNCTION Param::GetParameterValue(double* pdouble) {{{1*/
-#undef __FUNCT__ 
-#define __FUNCT__ "GetParameterValue"
 void  Param::GetParameterValue(double* pdouble){
 
-	if(type!=DOUBLE)throw ErrorException(__FUNCT__,exprintf("%s%i"," error message: trying to recover a double from a param with type",type));
+	if(type!=DOUBLE)ISSMERROR(exprintf("%s%i"," error message: trying to recover a double from a param with type",type));
 	*pdouble=ddouble;
 }
 /*}}}*/
 /*FUNCTION Param::GetParameterValue(int* pinteger) {{{1*/
-#undef __FUNCT__ 
-#define __FUNCT__ "GetParameterValue"
 void  Param::GetParameterValue(int* pinteger){
 	
-	if(type!=DOUBLE)throw ErrorException(__FUNCT__,exprintf("%s%i"," error message: trying to recover an integer from a param with type",type));
+	if(type!=DOUBLE)ISSMERROR(exprintf("%s%i"," error message: trying to recover an integer from a param with type",type));
 	*pinteger=(int)ddouble;
 }
 /*}}}*/
 /*FUNCTION Param::GetParameterValue(char** pstring) {{{1*/
-#undef __FUNCT__ 
-#define __FUNCT__ "GetParameterValue"
 void  Param::GetParameterValue(char** pstring){
 	
 	char*  outstring=NULL;
 	
-	if(type!=STRING)throw ErrorException(__FUNCT__,exprintf("%s%i"," error message: trying to recover a string from a param with type",type));
+	if(type!=STRING)ISSMERROR(exprintf("%s%i"," error message: trying to recover a string from a param with type",type));
 	outstring=(char*)xmalloc((strlen(string)+1)*sizeof(char));
 	strcpy(outstring,string);
@@ -579,10 +563,8 @@
 /*}}}*/
 /*FUNCTION Param::GetParameterValue(char*** pstringarray) {{{1*/
-#undef __FUNCT__ 
-#define __FUNCT__ "GetParameterValue"
 void  Param::GetParameterValue(char*** pstringarray){
 
 	int i;
-	if(type!=STRINGARRAY)throw ErrorException(__FUNCT__,exprintf("%s%i"," error message: trying to recover a string array from a param with type",type));
+	if(type!=STRINGARRAY)ISSMERROR(exprintf("%s%i"," error message: trying to recover a string array from a param with type",type));
 
 	char**  outstringarray=NULL;
@@ -597,6 +579,4 @@
 /*}}}*/
 /*FUNCTION Param::GetParameterValue(double** pdoublearray) {{{1*/
-#undef __FUNCT__ 
-#define __FUNCT__ "GetParameterValue"
 	
 void  Param::GetParameterValue(double** pdoublearray){
@@ -605,5 +585,5 @@
 	double* outdoublearray=NULL;
 	
-	if((type!=DOUBLEVEC) & (type!=DOUBLEMAT)) throw ErrorException(__FUNCT__,exprintf("%s%i"," error message: trying to recover a double array from a param with type",type));
+	if((type!=DOUBLEVEC) & (type!=DOUBLEMAT)) ISSMERROR(exprintf("%s%i"," error message: trying to recover a double array from a param with type",type));
 	
 	if(type==DOUBLEVEC){
@@ -627,11 +607,9 @@
 /*}}}*/
 /*FUNCTION Param::GetParameterValue(Vec* pvec) {{{1*/
-#undef __FUNCT__ 
-#define __FUNCT__ "GetParameterValue"
 void  Param::GetParameterValue(Vec* pvec){
 	
 	Vec  outvec=NULL;
 	
-	if(type!=PETSCVEC)  throw ErrorException(__FUNCT__,exprintf("%s%i"," error message: trying to recover a Petsc vec from a param with type",type));
+	if(type!=PETSCVEC)  ISSMERROR(exprintf("%s%i"," error message: trying to recover a Petsc vec from a param with type",type));
 
 	if(vec){
@@ -657,25 +635,19 @@
 /*}}}*/
 /*FUNCTION Param::SetDouble(double value) {{{1*/
-#undef __FUNCT__
-#define __FUNCT__ "SetDouble"
 void  Param::SetDouble(double value){
-	if (type!=DOUBLE) throw ErrorException(__FUNCT__,exprintf("%s%i"," trying to set double for type",type));
+	if (type!=DOUBLE) ISSMERROR(exprintf("%s%i"," trying to set double for type",type));
 	ddouble=value;
 }
 /*}}}*/
 /*FUNCTION Param::SetDouble(int value) {{{1*/
-#undef __FUNCT__
-#define __FUNCT__ "SetDouble"
 void  Param::SetDouble(int value){
-	if (type!=DOUBLE) throw ErrorException(__FUNCT__,exprintf("%s%i"," trying to set double for type",type));
+	if (type!=DOUBLE) ISSMERROR(exprintf("%s%i"," trying to set double for type",type));
 	ddouble=(double)value;
 }
 /*}}}*/
 /*FUNCTION Param::SetDoubleMat {{{1*/
-#undef __FUNCT__
-#define __FUNCT__ "SetDoubleMat"
 void  Param::SetDoubleMat(double* value,int pM,int pN){
 	
-	if (type!=DOUBLEMAT) throw ErrorException(__FUNCT__,exprintf("%s%i"," trying to set doublematrix type",type));
+	if (type!=DOUBLEMAT) ISSMERROR(exprintf("%s%i"," trying to set doublematrix type",type));
 
 	this->M=pM;
@@ -688,8 +660,6 @@
 /*}}}*/
 /*FUNCTION Param::SetDoubleVec(double* value,int size) {{{1*/
-#undef __FUNCT__
-#define __FUNCT__ "SetDoubleVec"
 void  Param::SetDoubleVec(double* value,int size){
-	if (type!=DOUBLEVEC) throw ErrorException(__FUNCT__,exprintf("%s%i"," trying to set doublevecfor type",type));
+	if (type!=DOUBLEVEC) ISSMERROR(exprintf("%s%i"," trying to set doublevecfor type",type));
 	
 	M=size;
@@ -706,8 +676,6 @@
 /*}}}*/
 /*FUNCTION Param::SetDoubleVec(double* value,int size, int numberofdofs) {{{1*/
-#undef __FUNCT__
-#define __FUNCT__ "SetDoubleVec"
 void  Param::SetDoubleVec(double* value,int size, int numberofdofs){
-	if (type!=DOUBLEVEC) throw ErrorException(__FUNCT__,exprintf("%s%i"," trying to set doublevecfor type",type));
+	if (type!=DOUBLEVEC) ISSMERROR(exprintf("%s%i"," trying to set doublevecfor type",type));
 	
 	M=size;
@@ -720,18 +688,14 @@
 /*}}}*/
 /*FUNCTION Param::SetString {{{1*/
-#undef __FUNCT__
-#define __FUNCT__ "SetString"
 void  Param::SetString(char* value){
-	if (type!=STRING) throw ErrorException(__FUNCT__,exprintf("%s%i"," trying to set string for type",type));
+	if (type!=STRING) ISSMERROR(exprintf("%s%i"," trying to set string for type",type));
 	strcpy(string,value);
 }
 /*}}}*/
 /*FUNCTION Param::SetStringArray {{{1*/
-#undef __FUNCT__
-#define __FUNCT__ "SetStringArray"
 void  Param::SetStringArray(char** value,int size){
 	
 	int i;
-	if (type!=STRINGARRAY) throw ErrorException(__FUNCT__,exprintf("%s%i"," trying to set string for type",type));
+	if (type!=STRINGARRAY) ISSMERROR(exprintf("%s%i"," trying to set string for type",type));
 	M=size;
 	stringarray=(char**)xmalloc(M*sizeof(char*));
@@ -744,6 +708,4 @@
 /*}}}*/
 /*FUNCTION Param::SetVec {{{1*/
-#undef __FUNCT__
-#define __FUNCT__ "SetVec"
 void  Param::SetVec(Vec value){
 