Index: issm/trunk/externalpackages/petsc/configs/2.3.2-p3/altix64/configure.sh
===================================================================
--- issm/trunk/externalpackages/petsc/configs/2.3.2-p3/altix64/configure.sh	(revision 3339)
+++ issm/trunk/externalpackages/petsc/configs/2.3.2-p3/altix64/configure.sh	(revision 3339)
@@ -0,0 +1,9 @@
+#After Plapack is fixed
+
+#set PETSC_DIR variable, in case.
+PETSC_DIR=$ISSM_DIR/externalpackages/petsc/install
+
+./config/configure.py  --prefix=$PETSC_DIR --with-batch=1  --ISSM_ARCH=$ISSM_ARCH --PETSC_DIR=$PETSC_DIR   --with-debugging=no --with-shared=0 COPTFLAGS=-O3 FOPTFLAGS=-O3 --with-blas-lapack-dir=/opt/intel/mkl/9.1.023 --with-mpi-lib=/usr/lib/libmpi.so --with-mpi-include=/usr/include  --with-mpi-shared=0 --download-mumps=yes --download-scalapack=yes --download-blacs=yes  --with-plapack-dir=$PETSC_DIR/externalpackages/PLAPACKR32-hg/$ISSM_ARCH --FFLAGS=-I/usr/include --with-cc=icc --with-fc=ifort
+
+#Before Plapack implodes
+#./config/configure.py  --prefix=$PETSC_DIR --with-batch=1  --ISSM_ARCH=$ISSM_ARCH --PETSC_DIR=$PETSC_DIR   --with-debugging=no --with-shared=0 COPTFLAGS=-O3 FOPTFLAGS=-O3 --with-blas-lapack-dir=/opt/intel/mkl/9.1.023 --with-mpi-lib=/usr/lib/libmpi.so --with-mpi-include=/usr/include  --with-mpi-shared=0 --download-mumps=yes --download-scalapack=yes --download-blacs=yes  --download-plapack=yes --FFLAGS=-I/usr/include --with-cc=icc --with-fc=ifort
Index: issm/trunk/externalpackages/petsc/configs/2.3.2-p3/linux32-cosmos/configure.sh
===================================================================
--- issm/trunk/externalpackages/petsc/configs/2.3.2-p3/linux32-cosmos/configure.sh	(revision 3339)
+++ issm/trunk/externalpackages/petsc/configs/2.3.2-p3/linux32-cosmos/configure.sh	(revision 3339)
@@ -0,0 +1,3 @@
+PETSC_DIR=$ISSM_DIR/externalpackages/petsc/install
+
+./config/configure.py  --prefix=$PETSC_DIR --with-batch=1  --ISSM_ARCH=$ISSM_ARCH --PETSC_DIR=$PETSC_DIR   --with-debugging=no COPTFLAGS=-O3 FOPTFLAGS=-O3 --with-blas-lapack-dir=/opt/intel/mkl/10.0.5.025/ --with-mpi-dir=/opt/mpich/gm/intel10.1/  --download-mumps=yes --download-scalapack=yes --download-blacs=yes  --download-plapack=yes --FFLAGS=-I/usr/include  --with-mpi-shared=0
Index: issm/trunk/externalpackages/petsc/configs/2.3.2-p3/linux64/configure.sh
===================================================================
--- issm/trunk/externalpackages/petsc/configs/2.3.2-p3/linux64/configure.sh	(revision 3339)
+++ issm/trunk/externalpackages/petsc/configs/2.3.2-p3/linux64/configure.sh	(revision 3339)
@@ -0,0 +1,2 @@
+#!/bin/bash
+./config/configure.py  --prefix="$ISSM_DIR/externalpackages/petsc/install" --with-mpi-dir=$ISSM_DIR/externalpackages/mpich2/install --PETSC_ARCH=linux-gnu-amd64 --PETSC_DIR="$ISSM_DIR/externalpackages/petsc/install" --with-fc=gfortran --with-debugging=1 --with-shared=0 --download-mumps=yes --download-scalapack=yes --download-blacs=yes --download-blas=yes --download-f-blas-lapack=yes --FFLAGS=-I$ISSM_DIR/externalpackages/mpich2/install/include --download-plapack=yes --COPTFLAGS="-march=opteron -O2" --FOPTFLAGS="-march=opteron -O2" --CXXOPTFLAGS="-march=opteron -O2" 
Index: issm/trunk/externalpackages/petsc/configs/2.3.2-p3/macosx32/configure.sh
===================================================================
--- issm/trunk/externalpackages/petsc/configs/2.3.2-p3/macosx32/configure.sh	(revision 3339)
+++ issm/trunk/externalpackages/petsc/configs/2.3.2-p3/macosx32/configure.sh	(revision 3339)
@@ -0,0 +1,2 @@
+#!/bin/bash
+./config/configure.py  --prefix="$ISSM_DIR/externalpackages/petsc/install" --with-mpi-dir=$ISSM_DIR/externalpackages/mpich2/install --PETSC_ARCH=macosx-gnu --PETSC_DIR="$ISSM_DIR/externalpackages/petsc/install" --with-fc=/usr/local/bin/gfortran --with-debugging=0 --with-shared=0 --download-mumps=yes --download-scalapack=yes --download-blacs=yes --download-blas=yes --download-f-blas-lapack=yes --FFLAGS="-I$ISSM_DIR/externalpackages/mpich2/install/include -L$ISSM_DIR/externalpackages/mpich2/install/lib -L/usr/local/bin -lmpich -lpmpich -lgfortran" --download-plapack=yes
Index: issm/trunk/externalpackages/petsc/configs/2.3.2-p3/pleiades/configure.sh
===================================================================
--- issm/trunk/externalpackages/petsc/configs/2.3.2-p3/pleiades/configure.sh	(revision 3339)
+++ issm/trunk/externalpackages/petsc/configs/2.3.2-p3/pleiades/configure.sh	(revision 3339)
@@ -0,0 +1,9 @@
+#After Plapack is fixed
+
+#set PETSC_DIR variable, in case.
+PETSC_DIR=$ISSM_DIR/externalpackages/petsc/install
+
+./config/configure.py  --prefix=$PETSC_DIR --with-batch=1  --PETSC_ARCH=$ISSM_ARCH --PETSC_DIR=$PETSC_DIR   --with-debugging=no --with-shared=0 --with-blas-lapack-dir=/nasa/intel/mkl/10.0.011/ --with-mpi-lib=/nasa/sgi/mpt/1.23.nas/lib64/libmpi.so --with-mpi-include=/nasa/sgi/mpt/1.23.nas/include  --with-mpi-shared=0 --download-mumps=yes --download-scalapack=yes --download-blacs=yes  --with-plapack-dir=$PETSC_DIR/externalpackages/PLAPACKR32-hg/$ISSM_ARCH --FFLAGS=-I/usr/include --with-cc=icc --with-fc=ifort --COPTFLAGS=" -O3 -xS" --FOPTFLAGS=" -O3 -xS" --CXXOPTFLAGS=" -O3 -xS"
+
+#Before Plapack implodes
+#./config/configure.py  --prefix=$PETSC_DIR --with-batch=1  --PETSC_ARCH=$ISSM_ARCH --PETSC_DIR=$PETSC_DIR   --with-debugging=no --with-shared=0 --with-blas-lapack-dir=/nasa/intel/mkl/10.0.011/ --with-mpi-lib=/nasa/sgi/mpt/1.23.nas/lib64/libmpi.so --with-mpi-include=/nasa/sgi/mpt/1.23.nas/include  --with-mpi-shared=0 --download-mumps=yes --download-scalapack=yes --download-blacs=yes  --download-plapack=yes --FFLAGS=-I/usr/include --with-cc=icc --with-fc=ifort --COPTFLAGS=" -O3 -xS" --FOPTFLAGS=" -O3 -xS" --CXXOPTFLAGS=" -O3 -xS"
Index: issm/trunk/externalpackages/petsc/configs/2.3.2-p3/winxp32/configure.sh
===================================================================
--- issm/trunk/externalpackages/petsc/configs/2.3.2-p3/winxp32/configure.sh	(revision 3339)
+++ issm/trunk/externalpackages/petsc/configs/2.3.2-p3/winxp32/configure.sh	(revision 3339)
@@ -0,0 +1,2 @@
+#!/bin/bash
+./config/configure.py  --with-parallel-no --prefix="$ISSM_DIR/externalpackages/petsc/install" --PETSC_ARCH=cygwin-intel --PETSC_DIR="$ISSM_DIR/externalpackages/petsc/install" --with-debugging=0 --with-mpi=0 --download-c-blas-lapack=1