Index: issm/trunk/src/c/objects/Penta.cpp
===================================================================
--- issm/trunk/src/c/objects/Penta.cpp	(revision 3529)
+++ issm/trunk/src/c/objects/Penta.cpp	(revision 3567)
@@ -81,5 +81,5 @@
 	//elements of type 3 are macayeal type penta. we collapse the formulation on their base.
 	if(iomodel->elements_type){
-		if (*(iomodel->elements_type+2*i+0)==MacAyealFormulationEnum()){ 
+		if (*(iomodel->elements_type+2*i+0)==MacAyealFormulationEnum){ 
 			this->properties.collapse=1;
 		}
@@ -196,5 +196,5 @@
 
 	/*get enum type of Penta: */
-	enum_type=PentaEnum();
+	enum_type=PentaEnum;
 
 	/*marshall enum: */
@@ -387,5 +387,5 @@
 
 	/*Check analysis_types*/
-	if (analysis_type!=DiagnosticAnalysisEnum() || sub_analysis_type!=StokesAnalysisEnum()) ISSMERROR("Not supported yet!");
+	if (analysis_type!=DiagnosticAnalysisEnum || sub_analysis_type!=StokesAnalysisEnum) ISSMERROR("Not supported yet!");
 
 	/*recover pointers: */
@@ -555,20 +555,20 @@
 
 	/*Just branch to the correct element stiffness matrix generator, according to the type of analysis we are carrying out: */
-	if (analysis_type==ControlAnalysisEnum()){
+	if (analysis_type==ControlAnalysisEnum){
 
 		CreateKMatrixDiagnosticHoriz( Kgg,inputs,analysis_type,sub_analysis_type);
 
 	}
-	else if (analysis_type==DiagnosticAnalysisEnum()){
-
-		if (sub_analysis_type==HorizAnalysisEnum()){
+	else if (analysis_type==DiagnosticAnalysisEnum){
+
+		if (sub_analysis_type==HorizAnalysisEnum){
 
 			CreateKMatrixDiagnosticHoriz( Kgg,inputs,analysis_type,sub_analysis_type);
 		}
-		else if (sub_analysis_type==VertAnalysisEnum()){
+		else if (sub_analysis_type==VertAnalysisEnum){
 
 			CreateKMatrixDiagnosticVert( Kgg,inputs,analysis_type,sub_analysis_type);
 		}
-		else if (sub_analysis_type==StokesAnalysisEnum()){
+		else if (sub_analysis_type==StokesAnalysisEnum){
 
 			CreateKMatrixDiagnosticStokes( Kgg,inputs,analysis_type,sub_analysis_type);
@@ -577,25 +577,25 @@
 		else ISSMERROR(exprintf("%s%i%s\n","sub_analysis: ",sub_analysis_type," not supported yet"));
 	}
-	else if (analysis_type==SlopecomputeAnalysisEnum()){
+	else if (analysis_type==SlopecomputeAnalysisEnum){
 
 		CreateKMatrixSlopeCompute( Kgg,inputs,analysis_type,sub_analysis_type);
 	}
-	else if (analysis_type==PrognosticAnalysisEnum()){
+	else if (analysis_type==PrognosticAnalysisEnum){
 
 		CreateKMatrixPrognostic( Kgg,inputs,analysis_type,sub_analysis_type);
 	}
-	else if (analysis_type==BalancedthicknessAnalysisEnum()){
+	else if (analysis_type==BalancedthicknessAnalysisEnum){
 
 		CreateKMatrixBalancedthickness( Kgg,inputs,analysis_type,sub_analysis_type);
 	}
-	else if (analysis_type==BalancedvelocitiesAnalysisEnum()){
+	else if (analysis_type==BalancedvelocitiesAnalysisEnum){
 
 		CreateKMatrixBalancedvelocities( Kgg,inputs,analysis_type,sub_analysis_type);
 	}
-	else if (analysis_type==ThermalAnalysisEnum()){
+	else if (analysis_type==ThermalAnalysisEnum){
 
 		CreateKMatrixThermal( Kgg,inputs,analysis_type,sub_analysis_type);
 	}
-	else if (analysis_type==MeltingAnalysisEnum()){
+	else if (analysis_type==MeltingAnalysisEnum){
 
 		CreateKMatrixMelting( Kgg,inputs,analysis_type,sub_analysis_type);
@@ -1683,19 +1683,19 @@
 
 	/*Just branch to the correct element stiffness matrix generator, according to the type of analysis we are carrying out: */
-	if (analysis_type==ControlAnalysisEnum()){
+	if (analysis_type==ControlAnalysisEnum){
 
 		CreatePVectorDiagnosticHoriz( pg,inputs,analysis_type,sub_analysis_type);
 	}
-	else if (analysis_type==DiagnosticAnalysisEnum()){
-
-		if (sub_analysis_type==HorizAnalysisEnum()){
+	else if (analysis_type==DiagnosticAnalysisEnum){
+
+		if (sub_analysis_type==HorizAnalysisEnum){
 
 			CreatePVectorDiagnosticHoriz( pg,inputs,analysis_type,sub_analysis_type);
 		}
-		else if (sub_analysis_type==VertAnalysisEnum()){
+		else if (sub_analysis_type==VertAnalysisEnum){
 
 			CreatePVectorDiagnosticVert( pg,inputs,analysis_type,sub_analysis_type);
 		}
-		else if (sub_analysis_type==StokesAnalysisEnum()){
+		else if (sub_analysis_type==StokesAnalysisEnum){
 
 			CreatePVectorDiagnosticStokes( pg,inputs,analysis_type,sub_analysis_type);
@@ -1703,25 +1703,25 @@
 		else ISSMERROR(exprintf("%s%i%s\n","sub_analysis: ",sub_analysis_type," not supported yet"));
 	}
-	else if (analysis_type==SlopecomputeAnalysisEnum()){
+	else if (analysis_type==SlopecomputeAnalysisEnum){
 
 		CreatePVectorSlopeCompute( pg,inputs,analysis_type,sub_analysis_type);
 	}
-	else if (analysis_type==PrognosticAnalysisEnum()){
+	else if (analysis_type==PrognosticAnalysisEnum){
 
 		CreatePVectorPrognostic( pg,inputs,analysis_type,sub_analysis_type);
 	}
-	else if (analysis_type==BalancedthicknessAnalysisEnum()){
+	else if (analysis_type==BalancedthicknessAnalysisEnum){
 
 		CreatePVectorBalancedthickness( pg,inputs,analysis_type,sub_analysis_type);
 	}
-	else if (analysis_type==BalancedvelocitiesAnalysisEnum()){
+	else if (analysis_type==BalancedvelocitiesAnalysisEnum){
 
 		CreatePVectorBalancedvelocities( pg,inputs,analysis_type,sub_analysis_type);
 	}
-	else if (analysis_type==ThermalAnalysisEnum()){
+	else if (analysis_type==ThermalAnalysisEnum){
 
 		CreatePVectorThermal( pg,inputs,analysis_type,sub_analysis_type);
 	}
-	else if (analysis_type==MeltingAnalysisEnum()){
+	else if (analysis_type==MeltingAnalysisEnum){
 
 		CreatePVectorMelting( pg,inputs,analysis_type,sub_analysis_type);
@@ -2620,5 +2620,5 @@
 int Penta::Enum(void){
 
-	return PentaEnum();
+	return PentaEnum;
 
 }
@@ -4059,5 +4059,5 @@
 	if (!this->properties.onbed) return;
 
-	if (sub_analysis_type==HorizAnalysisEnum()){
+	if (sub_analysis_type==HorizAnalysisEnum){
 
 		/*MacAyeal or Pattyn*/
@@ -4067,5 +4067,5 @@
 		return;
 	}
-	else if (sub_analysis_type==StokesAnalysisEnum()){
+	else if (sub_analysis_type==StokesAnalysisEnum){
 
 		/*Stokes*/