Index: issm/trunk/src/c/objects/Beam.cpp
===================================================================
--- issm/trunk/src/c/objects/Beam.cpp	(revision 3590)
+++ issm/trunk/src/c/objects/Beam.cpp	(revision 3591)
@@ -738,35 +738,4 @@
 }
 /*}}}*/
-/*FUNCTION Beam::MaticeConfiguration{{{1*/
-void  Beam::MaticeConfiguration(Matice* beam_matice,int beam_matice_offset){
-
-	/*dynamic objects pointed to by hooks: */
-	Matice* matice=NULL;
-
-	/*recover objects from hooks: */
-	matice=(Matice*)hmatice.delivers();
-	
-	ISSMERROR("not supported yet!");
-
-	/*matice=beam_matice;
-	matice_offset=beam_matice_offset;*/
-}
-/*}}}*/
-/*FUNCTION Beam::MatparConfiguration{{{1*/
-void  Beam::MatparConfiguration(Matpar* beam_matpar,int beam_matpar_offset){
-
-	/*dynamic objects pointed to by hooks: */
-	Matpar* matpar=NULL;
-
-	/*recover objects from hooks: */
-	matpar=(Matpar*)hmatpar.delivers();
-
-	ISSMERROR("not supported yet!");
-
-	/*matpar=beam_matpar;
-	matpar_offset=beam_matpar_offset;*/
-
-}
-/*}}}*/
 /*FUNCTION Beam::Misfit{{{1*/
 double Beam::Misfit(void*,int,int){
@@ -780,24 +749,4 @@
 }
 /*}}}*/
-/*FUNCTION Beam::NodeConfiguration{{{1*/
-void  Beam::NodeConfiguration(int* beam_node_ids,Node* beam_nodes[2],int* beam_node_offsets){
-
-	/*dynamic objects pointed to by hooks: */
-	Node**  nodes=NULL;
-
-	/*recover objects from hooks: */
-	nodes=(Node**)hnodes.deliverp();
-
-	ISSMERROR("not supported yet!");
-
-	/*int i;
-	for(i=0;i<2;i++){
-		node_ids[i]=beam_node_ids[i];
-		nodes[i]=beam_nodes[i];
-		node_offsets[i]=beam_node_offsets[i];
-	}*/
-
-}
-/*}}}*/
 /*FUNCTION Beam::SurfaceArea{{{1*/
 double Beam::SurfaceArea(void*,int,int){
Index: issm/trunk/src/c/objects/Beam.h
===================================================================
--- issm/trunk/src/c/objects/Beam.h	(revision 3590)
+++ issm/trunk/src/c/objects/Beam.h	(revision 3591)
@@ -71,7 +71,4 @@
 		void* GetMatPar();
 
-		void  NodeConfiguration(int* beam_node_ids,Node* beam_nodes[2],int* beam_node_offsets);
-		void  MaticeConfiguration(Matice* matice,int matice_offset);
-		void  MatparConfiguration(Matpar* matpar,int matpar_offset);
 		void  ComputeBasalStress(Vec sigma_b,void* inputs,int analysis_type,int sub_analysis_type);
 		void  ComputePressure(Vec p_g,void* inputs,int analysis_type,int sub_analysis_type);
Index: issm/trunk/src/c/objects/Sing.cpp
===================================================================
--- issm/trunk/src/c/objects/Sing.cpp	(revision 3590)
+++ issm/trunk/src/c/objects/Sing.cpp	(revision 3591)
@@ -590,35 +590,4 @@
 }
 /*}}}*/
-/*FUNCTION Sing::MaticeConfiguration {{{1*/
-void  Sing::MaticeConfiguration(Matice* sing_matice,int sing_matice_offset){
-
-	/*dynamic objects pointed to by hooks: */
-	Matice* matice=NULL;
-
-	/*recover objects from hooks: */
-	matice=(Matice*)hmatice.delivers();
-	
-	ISSMERROR("not supported yet!");
-
-	/*matice=sing_matice;
-	matice_offset=sing_matice_offset;*/
-}
-/*}}}*/
-/*FUNCTION Sing::MatparConfiguration {{{1*/
-void  Sing::MatparConfiguration(Matpar* sing_matpar,int sing_matpar_offset){
-
-	/*dynamic objects pointed to by hooks: */
-	Matpar* matpar=NULL;
-
-	/*recover objects from hooks: */
-	matpar=(Matpar*)hmatpar.delivers();
-
-	ISSMERROR("not supported yet!");
-
-	/*matpar=sing_matpar;
-	matpar_offset=sing_matpar_offset;*/
-
-}
-/*}}}*/
 /*FUNCTION Sing::Misfit {{{1*/
 double Sing::Misfit(void*, int,int){
Index: issm/trunk/src/c/objects/Sing.h
===================================================================
--- issm/trunk/src/c/objects/Sing.h	(revision 3590)
+++ issm/trunk/src/c/objects/Sing.h	(revision 3591)
@@ -65,7 +65,4 @@
 		void  CreatePVectorDiagnosticHutter(Vec pg,void* inputs,int analysis_type,int sub_analysis_type);
 		void* GetMatPar();
-		void  NodeConfiguration(int sing_node_id,Node* sing_node,int sing_node_offset);
-		void  MaticeConfiguration(Matice* matice,int matice_offset);
-		void  MatparConfiguration(Matpar* matpar,int matpar_offset);
 		void  ComputeBasalStress(Vec sigma_b,void* inputs,int analysis_type,int sub_analysis_type);
 		void  ComputePressure(Vec p_g,void* inputs,int analysis_type,int sub_analysis_type);